Index: trunk/src/VBox/Devices/EFI/FirmwareNew/BaseTools/Source/C/GenFw/GenFw.c
===================================================================
--- trunk/src/VBox/Devices/EFI/FirmwareNew/BaseTools/Source/C/GenFw/GenFw.c	(revision 77875)
+++ trunk/src/VBox/Devices/EFI/FirmwareNew/BaseTools/Source/C/GenFw/GenFw.c	(revision 77876)
@@ -46,4 +46,8 @@
 
 #include "GenFw.h"
+
+#ifdef __GNUC__
+#pragma GCC diagnostic ignored "-Wlogical-op"
+#endif
 
 //
Index: trunk/src/VBox/Devices/EFI/FirmwareNew/BaseTools/Source/C/LzmaCompress/Makefile.kmk
===================================================================
--- trunk/src/VBox/Devices/EFI/FirmwareNew/BaseTools/Source/C/LzmaCompress/Makefile.kmk	(revision 77875)
+++ trunk/src/VBox/Devices/EFI/FirmwareNew/BaseTools/Source/C/LzmaCompress/Makefile.kmk	(revision 77876)
@@ -30,12 +30,11 @@
 BLDPROGS += LzmaCompress
 LzmaCompress_TEMPLATE = VBoxEfiBldProg
+LzmaCompress_DEFS = _7ZIP_ST
 LzmaCompress_SOURCES = \
 	LzmaCompress.c \
 	Sdk/C/Alloc.c \
 	Sdk/C/LzFind.c \
-	Sdk/C/LzFindMt.c \
 	Sdk/C/LzmaDec.c \
 	Sdk/C/LzmaEnc.c \
-	Sdk/C/Threads.c \
 	Sdk/C/7zFile.c \
 	Sdk/C/7zStream.c \
@@ -44,5 +43,5 @@
 BLDPROGS += LzmaF86Compress
 LzmaF86Compress_EXTENDS = LzmaCompress
-LzmaF86Compress_DEFS = VBOX_LZMA_F86_COMPRESS
+LzmaF86Compress_DEFS = VBOX_LZMA_F86_COMPRESS _7ZIP_ST
 
 include $(FILE_KBUILD_SUB_FOOTER)
Index: trunk/src/VBox/Devices/EFI/FirmwareNew/BaseTools/Source/C/VfrCompile/Pccts/antlr/antlr.c
===================================================================
--- trunk/src/VBox/Devices/EFI/FirmwareNew/BaseTools/Source/C/VfrCompile/Pccts/antlr/antlr.c	(revision 77875)
+++ trunk/src/VBox/Devices/EFI/FirmwareNew/BaseTools/Source/C/VfrCompile/Pccts/antlr/antlr.c	(revision 77876)
@@ -46,4 +46,7 @@
 #    pragma warning(disable : 4068) /* Unguarded '#pragma clang' below */
 #  endif
+#  ifdef __GNUC__
+#    pragma GCC diagnostic ignored "-Wunknown-pragmas"
+#endif
 #endif
 
Index: trunk/src/VBox/Devices/EFI/FirmwareNew/BaseTools/Source/C/VfrCompile/Pccts/antlr/fset.c
===================================================================
--- trunk/src/VBox/Devices/EFI/FirmwareNew/BaseTools/Source/C/VfrCompile/Pccts/antlr/fset.c	(revision 77875)
+++ trunk/src/VBox/Devices/EFI/FirmwareNew/BaseTools/Source/C/VfrCompile/Pccts/antlr/fset.c	(revision 77876)
@@ -1528,5 +1528,5 @@
                     save_maintainBackTrace=MR_MaintainBackTrace;
                     if (AlphaBetaTrace) MR_MaintainBackTrace=0;
-					HandleAmbiguity(j, alt1, alt2, jtype);
+		    HandleAmbiguity(j, alt1, alt2, jtype);
                     MR_MaintainBackTrace=save_maintainBackTrace;
 					break;
Index: trunk/src/VBox/Devices/EFI/FirmwareNew/BaseTools/Source/C/VfrCompile/Pccts/antlr/proto.h
===================================================================
--- trunk/src/VBox/Devices/EFI/FirmwareNew/BaseTools/Source/C/VfrCompile/Pccts/antlr/proto.h	(revision 77875)
+++ trunk/src/VBox/Devices/EFI/FirmwareNew/BaseTools/Source/C/VfrCompile/Pccts/antlr/proto.h	(revision 77876)
@@ -392,4 +392,9 @@
 extern void fatalFL( char *, char *, int );
 extern void fatal_intern( char *, char *, int );
+#ifdef VBOX
+#  ifdef __GNUC__
+extern void __attribute__((noreturn)) fatal_intern( char *, char *, int );
+#  endif
+#endif
 extern void cleanUp( void );
 extern char * eMsg3( char *, char *, char *, char * );
Index: trunk/src/VBox/Devices/EFI/FirmwareNew/BaseTools/Source/C/VfrCompile/Pccts/dlg/dlg_p.c
===================================================================
--- trunk/src/VBox/Devices/EFI/FirmwareNew/BaseTools/Source/C/VfrCompile/Pccts/dlg/dlg_p.c	(revision 77875)
+++ trunk/src/VBox/Devices/EFI/FirmwareNew/BaseTools/Source/C/VfrCompile/Pccts/dlg/dlg_p.c	(revision 77876)
@@ -43,4 +43,7 @@
 #  ifdef _MSC_VER
 #    pragma warning(disable : 4068) /* Unguarded '#pragma clang' below */
+#  endif
+#  ifdef __GNUC__
+#    pragma GCC diagnostic ignored "-Wunknown-pragmas"
 #  endif
 #endif
Index: trunk/src/VBox/Devices/EFI/FirmwareNew/BaseTools/Source/C/VfrCompile/VfrUtilityLib.cpp
===================================================================
--- trunk/src/VBox/Devices/EFI/FirmwareNew/BaseTools/Source/C/VfrCompile/VfrUtilityLib.cpp	(revision 77875)
+++ trunk/src/VBox/Devices/EFI/FirmwareNew/BaseTools/Source/C/VfrCompile/VfrUtilityLib.cpp	(revision 77876)
@@ -690,4 +690,5 @@
   case '.' :
     VarStr++;
+    /* fall through */
   case '\0':
     return VFR_RETURN_SUCCESS;
Index: trunk/src/VBox/Devices/EFI/FirmwareNew/BaseTools/Source/C/VolInfo/VolInfo.c
===================================================================
--- trunk/src/VBox/Devices/EFI/FirmwareNew/BaseTools/Source/C/VolInfo/VolInfo.c	(revision 77875)
+++ trunk/src/VBox/Devices/EFI/FirmwareNew/BaseTools/Source/C/VolInfo/VolInfo.c	(revision 77876)
@@ -44,4 +44,8 @@
 #include "ParseInf.h"
 #include "PeCoffLib.h"
+
+#ifdef __GNUC__
+#pragma GCC diagnostic ignored "-Wimplicit-fallthrough"
+#endif
 
 //